#ifndef GAMESTATE_HPP
#define GAMESTATE_HPP

#include <Graphics/Texture.hpp>
#include <vector>

class GameState {
public:
	GameState();
	virtual ~GameState();
	std::vector<int> getDrawState();

	int def_A;	int def_B;	// if positive, enemy attacks less effective
	int hp_A;	int hp_B;	// if not positive, your turn is skipped
	int pts_A;	int pts_B;	// how many you have hung up
};

#endif // GAMESTATE_HPP
