#ifndef SERVER_HPP
#define SERVER_HPP

#include <Vector/Vector.hpp>

#include <sys/types.h>
#include <ctime>
#include <sys/socket.h>
#include <netdb.h>

#include <iostream>
#include <vector>
#include <string>

#include "GameState.hpp"

using std::vector;
using std::string;

class Server {
public:
	Server();
	virtual ~Server();
	virtual int connect_to_server(char *host, char *port);
	virtual void handshake(string name);
	virtual void sendMsg(string s);
	virtual int waitLoop(GameState* state);

	// Variables
	int sock;
	char* name;
	vector< uint8_t > write_buffer;
	vector< uint8_t > read_buffer;
};

#endif //SERVER_HPP
