#include "GameState.hpp"

// Callbacks

/*void update_check_cb(struct ev_loop *loop, ev_timer *watcher, int revents) {
	GameState *gs = (GameState *)watcher->data;
	cout << "active clients: " << endl;
	if (gs->player1 != NULL) {
		cout << "player1: " << gs->player1 << endl;
	}
	if (gs->player2 != NULL) {
		cout << "player2: " << gs->player2 << endl;
	}
	ev_timer_again(ev_default_loop(0), &(gs->update_watcher));
}*/

GameState::GameState() {
	game_on = false;
	comatose = false;
	player1 = NULL;
	player2 = NULL;
	
	//ev_timer_init(&update_watcher, update_check_cb, 0., 5.);
	//update_watcher.data = this;
	//ev_timer_again(ev_default_loop(0), &update_watcher);

	srand(time(NULL));
	if( rand()%2 ) {
		cout << "A goes first" << endl;
		turn_A = true;
	}
	else {
		cout << "B goes first" << endl;
		turn_A = false;
	}
	hp_A	= hp_B		= 1;
	def_A	= def_B		= 0;
	pts_A	= pts_B		= 0;
}

GameState::~GameState() {
	
}

void GameState::reinit() {
	game_on = false;
	comatose = false;
	player1 = NULL;
	player2 = NULL;

	srand(time(NULL));
	if( rand()%2 ) {
		cout << "A goes first" << endl;
		turn_A = true;
	}
	else {
		cout << "B goes first" << endl;
		turn_A = false;
	}
	hp_A	= hp_B		= 1;
	def_A	= def_B		= 0;
	pts_A	= pts_B		= 0;
}

void GameState::attack(Client* c) {
	bool youAreA = (c==player1);
	cout << " attacked ";///////////
	if (youAreA) {	
		def_A = 0;	// sacrifice defense for attack
	} else {		
		def_B = 0;
	}
	/*srand(time(NULL));
	int damage = rand()%2 ? 1 : 2;
		turn_A = true;
	}
	else {
		turn_A = false;
	}*/
	int damage = 1;
	if ((youAreA && (def_B > 0)) || (!youAreA && (def_A > 0))) {	// enemy is defending
		cout << " defended enemy and ";///////////
		if ((float) rand()/RAND_MAX < 0.2f) {	// hit
			cout << " hit. Enemy Unconsious. \n";///////////
			if (youAreA) {	hp_B -= damage;	def_B = -1;
			} else {	hp_A -= damage;	def_A = -1;
			}
		} else {	// miss
			cout << " missed. \n";///////////
		}
	} else {	// enemy is vulnerable
		cout << " vulnerable enemy and ";///////////
		if ((float) rand()/RAND_MAX < 0.7f) {
			cout << " hit. Enemy Unconsious. \n";///////////
			if (youAreA) {	hp_B -= damage;	def_B = -1;
			} else {	hp_A -= damage;	def_A = -1;
			}
		} else {	// miss
			cout << " missed. \n";///////////
		}
	}
	endedTurn(youAreA);
}
void GameState::defend(Client* c) {
	bool youAreA = c==player1;
	cout << " defended.\n";///////////
	if (youAreA) {	def_A += 3;
	} else {	def_B += 3;
	}
	endedTurn(youAreA);
}
void GameState::hang(Client* c) {
	bool youAreA = c == player1;
	cout << " hung clothes. \n";///////////
	if (pts_A + pts_B == 5) {	// push clothes off clothesline
		if (youAreA) {	pts_B--;
		} else {	pts_A--;
		}
	}
	// check if you filled the clothesline and won
	if (youAreA) {
		def_A = 0;	// sacrifice defense for point
		pts_A++;
		if (pts_A >= 5) {win(youAreA);}
	} else {
		def_B = 0;	// sacrifice defense for point
		pts_B++;
		if (pts_B >= 5) {win(youAreA);}
	}
	endedTurn(youAreA);
}
void GameState::endedTurn(bool youAreA) {
	cout << "turn ended. \n\nCURRENT SCORE: \n";
	cout << "\tA\t\tB \n";
	cout << "def:\t"<<(def_A>0)<<"\t\t"<<(def_B>0)<< endl;
	cout << "hp:\t"<<hp_A<<"\t\t"<<hp_B<< endl;
	cout << "pts:\t"<<pts_A<<"\t\t"<<pts_B<< endl;
	if (!finished()) {
		if (youAreA) {
			if (hp_B < 1) {
				if (comatose) {
					hp_B++;
					comatose = false;
				}
				else comatose = true;
				cout << "B comatose, skipping turn" << endl;
			}
			else {
				cout << "B's turn. B...\n";
				turn_A = !turn_A;
			}
		}
		else {
			if (hp_A < 1) {
				if (comatose) {
					hp_A++;
					comatose = false;
				}
				else comatose = true;
				cout << "A comatose, skipping turn" << endl;
			}
			else {
				cout << "A's turn. A...\n";
				turn_A = !turn_A;
			}
		}
	}
}

// game functions
bool GameState::get_turn(Client* c) {
	if (c==player1) return turn_A;
	else return !turn_A;
}

void GameState::win(bool aWon) {
	game_on = false;
	if (aWon) {
		hp_B = -10;
		cout << "Player A won! Player B lost.\n";
	} else {
		hp_A = -10;
		cout << "Player B won! Player A lost.\n";
	}
}

bool GameState::finished() {
	return (pts_A >= 5) || (pts_B >= 5);
}

